From aaef012875b3d784264549bbf6827fec0c6515bc Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 3/32] Issues: Use react widget


---

diff --git a/hubs/static/client/app/widgets/issues/Config.js b/hubs/static/client/app/widgets/issues/Config.js
new file mode 100644
index 0000000..5c5e4fc
--- /dev/null
+++ b/hubs/static/client/app/widgets/issues/Config.js
@@ -0,0 +1,52 @@
+import React from 'react';
+import {
+    defineMessages,
+    injectIntl,
+    FormattedMessage
+} from 'react-intl';
+
+
+const messages = defineMessages({
+    select_author: {
+        id: "hubs.widgets.halp.config.select.author",
+        defaultMessage: "Tickets I Filed",
+    },
+    select_assignee: {
+        id: "hubs.widgets.halp.config.select.assignee",
+        defaultMessage: "Tickets Waiting on Me",
+    },
+});
+
+
+class Config extends React.Component {
+
+    constructor(props) {
+        super(props);
+        this.handleModeChanged = this.handleModeChanged.bind(this);
+    }
+
+    handleModeChanged(e) {
+        this.props.setConfig("mode", e.target.value);
+    }
+
+    render() {
+        return (
+            <div className="form-group">
+                <label>Mode</label>
+                <select className="form-control"
+                        value={this.props.values.mode}
+                        onChange={this.handleModeChanged}>
+                    <option value={1}>
+                        <FormattedMessage {...messages.select_author} />
+                    </option>
+                    <option value={2}>
+                        <FormattedMessage {...messages.select_assignee} />
+                    </option>
+                </select>
+            </div>
+        );
+    }
+}
+
+
+export default injectIntl(Config);
diff --git a/hubs/static/client/app/widgets/issues/Widget.js b/hubs/static/client/app/widgets/issues/Widget.js
new file mode 100644
index 0000000..1c9a8d3
--- /dev/null
+++ b/hubs/static/client/app/widgets/issues/Widget.js
@@ -0,0 +1,133 @@
+import React from 'react';
+import {
+  widgetDidUpdate,
+  widgetWillUpdate
+} from "../../core/actions/widget";
+import WidgetChrome from '../../components/WidgetChrome';
+import PropTypes from "prop-types";
+import Spinner from "../../components/Spinner";
+
+
+export default class IssuesWidget extends React.PureComponent {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      issues: [],
+      counts: {},
+      isLoading: false
+    }
+  }
+
+  componentDidMount() {
+    if (!this.props.editMode) {
+      this.loadFromServer();
+    }
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+  }
+
+
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.needsUpdate && !this.props.editMode && !this.state.isLoading) {
+      this.loadFromServer();
+    }
+  }
+
+  loadFromServer() {
+    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
+    this.setState({isLoading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.widget.urls.data,
+      method: 'GET',
+      cache: false,
+      success: (res) => {
+        this.setState({
+            issues: res.data.issues,
+            counts: res.data.counts,
+            isLoading: false
+          },
+          () => (
+            this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
+          )
+        );
+      },
+      error: (xhr, status, err) => {
+        console.error(this.props.widget.urls.data, status, err.toString());
+        this.setState({isLoading: false});
+      }
+    });
+  }
+
+  render() {
+    return (
+      <WidgetChrome
+        widget={this.props.widget}
+        editMode={this.props.editMode}
+      >
+        <ul className="list-unstyled">
+          { this.state.isLoading && <Spinner className="p-3"/>}
+          {
+            this.state.issues.map((issue) => {
+              return (
+                <li key={issue.service + issue.number} className="py-2">
+                  <div className="row">
+                    <div className="col-md-6">
+                      <a  href={ issue.url }
+                          target="_blank" rel="noopener noreferrer">
+                        <span className="badge badge-primary">#{ issue.number }</span>
+                      </a>
+                    </div>
+                    <div className="col-md-6">
+                      <div className="float-right">
+                        <span>{ issue.project }</span>
+                        <img src={ issue.icon } style={{height: '16px'}} className={"ml-2"}/>
+                      </div>
+                    </div>
+                  </div>
+                  <div className="row">
+                    <div className="col-12">
+                      <span>{ issue.title }</span>
+                    </div>
+                  </div>
+                </li>
+              )
+            })
+          }
+        </ul>
+        <div className="card-footer p-1">
+          <div className="row p-1">
+            <div className="col-md-3 text-muted">
+              <span data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}>View More</span>
+            </div>
+            <div className="col-md-9 collapse" id={'counts'}>
+              <div className="row pt-0">
+                <div className="col-md-4 text-center">
+                  <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                  <span>Bugzilla ({ this.state.counts.bugzilla })</span>
+                </div>
+                <div className="col-md-4 text-center">
+                  <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                  <span>Github ({ this.state.counts.github })</span>
+                </div>
+                <div className="col-md-4 text-center">
+                  <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                  <span>Pagure ({ this.state.counts.pagure })</span>
+                </div>
+              </div>
+
+            </div>
+          </div>
+        </div>
+      </WidgetChrome>
+    )
+  }
+}
+
+IssuesWidget.propTypes = {
+  widget: PropTypes.object.isRequired,
+  editMode: PropTypes.bool,
+  needsUpdate: PropTypes.bool,
+};
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index c4bfd8f..343cef7 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -1,92 +1,55 @@
 from __future__ import unicode_literals
 
-from hubs.widgets import validators
-from hubs.widgets.base import Widget
-from hubs.widgets.caching import CachedFunction
-from hubs.widgets.view import RootWidgetView
+import arrow
+import flask
 
-import requests
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView
+from .functions import *
 
 
 class Issues(Widget):
 
     name = "issues"
     label = "Issues"
-    position = "left"
-    parameters = []
-
-
-class BaseView(RootWidgetView):
-
-    def get_context(self, instance, *args, **kwargs):
-        bugzilla_bugs = GetBugzillaBugs(instance)
-        github_issues = GetGithubIssues(instance)
-        pagure_issues = GetPagureIssues(instance)
-        return dict(
-            bugzilla_bugs=bugzilla_bugs(),
-            github_issues=github_issues(),
-            pagure_issues=pagure_issues()
+    position = "both"
+    parameters = [
+        dict(
+            name="mode",
+            default=1,
         )
+    ]
+    is_react = True
+
+    def get_props(self, instance, *args, **kwargs):
+        props = super(Issues, self).get_props(instance, *args, **kwargs)
+        if instance is not None:
+            hub_name = instance.hub.name
+            props.update(dict(
+                title="Issues - " +
+                      ("Tickets I Filed" if int(instance.config["mode"]) == 1 else "Tickets Waiting on Me"),
+                urls=dict(
+                    data=flask.url_for(
+                        "issues_data", hub=hub_name, idx=instance.idx),
+                )
+            ))
+        return props
+
+
+class DataView(WidgetView):
+    """Get issues in JSON format."""
+
+    name = "data"
+    url_rules = ["data"]
+    json = True
 
+    def get_context(self, instance, *args, **kwargs):
+        [bugzilla, bzcnt] = GetBugzillaBugs(instance)()
+        [pagure, pcnt] = GetPagureIssues(instance)()
+        [github, ghcnt] = GetGithubIssues(instance)()
 
-class GetBugzillaBugs(CachedFunction):
-
-    def execute(self):
-        email = self.instance.hub.config["bugzilla_email"]
-        endpoint = "https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{\"creator\":\"{}\"}}]"
-        response = requests.get(endpoint.format(email)).json()
-        issues = response['result']['bugs']
-        issues = issues[:min(5, len(issues))]
-        return issues
-
-    def should_invalidate(self, message):
-        return False
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return True
-
-    # For testing purposes
-    def _should_cache(self, value):
-        return False
-
-
-class GetPagureIssues(CachedFunction):
-
-    def execute(self):
-        username = self.instance.hub.config["pagure_username"]
-        endpoint = "https://pagure.io/api/0/user/{}/issues"
-        response = requests.get(endpoint.format(username)).json()
-        issues = response['issues_created']
-        issues = issues[:min(5, len(issues))]
-        return issues
-
-    def should_invalidate(self, message):
-        return False
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return True
-
-    # For testing purposes
-    def _should_cache(self, value):
-        return False
-
-
-class GetGithubIssues(CachedFunction):
-
-    def execute(self):
-        username = self.instance.hub.config["github_username"]
-        endpoint = "https://api.github.com/search/issues?q=is:issue+author:{}&sort:updated"
-        response = requests.get(endpoint.format(username)).json()
-        issues = response['items']
-        issues = issues[:min(5, len(issues))]
-        return issues
-
-    def should_invalidate(self, message):
-        return False
-
-    def should_invalidate_on_hub_config_change(self, old_config):
-        return True
+        all_issues = bugzilla + pagure + github
+        all_issues.sort(key=lambda x: arrow.get(x["updated_at"]), reverse=True)
 
-    # For testing purposes
-    def _should_cache(self, value):
-        return False
+        data = {"issues": all_issues, "counts": {"bugzilla": bzcnt, "pagure": pcnt, "github": ghcnt}}
+        return dict(status="OK", data=data)
diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
new file mode 100644
index 0000000..68b177d
--- /dev/null
+++ b/hubs/widgets/issues/functions.py
@@ -0,0 +1,95 @@
+import requests
+
+from hubs.widgets.caching import CachedFunction
+
+
+class GetBugzillaBugs(CachedFunction):
+
+    def execute(self):
+        email = self.instance.hub.config["bugzilla_email"]
+        endpoint = "https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{\"{}\":\"{}\"}}]"
+        mode = "creator" if int(self.instance.config["mode"]) == 1 else "assigned_to"
+        response = requests.get(endpoint.format(mode, email)).json()
+        issues = response['result']['bugs']
+        issues = issues[:min(5, len(issues))]
+        urltmpl = 'https://bugzilla.redhat.com/show_bug.cgi?id={}'
+        res = []
+        for issue in issues:
+            res.append(dict(
+                number=issue['id'],
+                title=issue['summary'],
+                project=issue['product'],
+                url=urltmpl.format(issue['id']),
+                updated_at=issue['last_change_time'],
+                service='bugzilla',
+                icon='https://bugzilla.redhat.com/favicon.ico'
+            ))
+        total_count = len(response['result']['bugs'])
+        return [res, total_count]
+
+    def should_invalidate(self, message):
+        return False
+
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
+
+
+class GetPagureIssues(CachedFunction):
+
+    def execute(self):
+        username = self.instance.hub.config["pagure_username"]
+        endpoint = "https://pagure.io/api/0/user/{}/issues?author={}"
+        author = "true" if int(self.instance.config["mode"]) == 1 else "false"
+        response = requests.get(endpoint.format(username, author)).json()
+        issues = response['issues_created'] if author == "true" else response['issues_assigned']
+        issues = issues[:min(5, len(issues))]
+        urltmpl = 'https://pagure.io/{}/issue/{}'
+        res = []
+        for issue in issues:
+            res.append(dict(
+                number=issue['id'],
+                title=issue['title'],
+                project=issue['project']['name'],
+                url=urltmpl.format(issue['project']['url_path'], issue['id']),
+                updated_at=issue['last_updated'],
+                service='pagure',
+                icon='https://pagure.io/static/favicon.ico'
+            ))
+        total_count = len(response['issues_created'] if author == "true" else response['issues_assigned'])
+        return [res, total_count]
+
+    def should_invalidate(self, message):
+        return False
+
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
+
+
+class GetGithubIssues(CachedFunction):
+
+    def execute(self):
+        username = self.instance.hub.config["github_username"]
+        endpoint = "https://api.github.com/search/issues?q=type:issue+{}:{}+state:open&sort:updated"
+        mode = "author" if int(self.instance.config["mode"]) == 1 else "assignee"
+        response = requests.get(endpoint.format(mode, username)).json()
+        issues = response['items']
+        issues = issues[:min(5, len(issues))]
+        res = []
+        for issue in issues:
+            res.append(dict(
+                number=issue['number'],
+                title=issue['title'],
+                project=issue['repository_url'].split('/')[-1],
+                url=issue['html_url'],
+                updated_at=issue['updated_at'],
+                service='github',
+                icon='https://github.com/favicon.ico'
+            ))
+        total_count = response['total_count']
+        return [res, total_count]
+
+    def should_invalidate(self, message):
+        return False
+
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
